package air.cairngorm.async.example.business
{
	import com.ericfeminella.air.cairngorm.business.AIRServiceLocator;
	import com.ericfeminella.air.cairngorm.business.ISQLResponder;
	import com.ericfeminella.air.cairngorm.business.SQLService;
	import com.ericfeminella.air.cairngorm.business.SQLStatementHelper;
	import air.cairngorm.async.example.vo.UserVO;
	
	public final class UserServiceDelegate
	{
		protected var responder:ISQLResponder;
		protected var sql:SQLService;
		
		public function UserServiceDelegate(responder:ISQLResponder)
		{
			this.responder = responder;
			this.sql = AIRServiceLocator.getInstance().getSQLService( Services.USERS_SERVICE );
		}
		
		public function createUserTable() : void
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.CREATE_TABLE );
			execute( statement );
		}
		
		public function addUser(user:UserVO) : void
		{	
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.INSERT, user.username, user.password );
			execute( statement );
		}
		
		public function deleteUser(username:String) : void
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.DELETE, username );
			execute( statement );
		}
		
		public function selectUsers() : void
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.SELECT );
			execute( statement );
		}
				
		public function updateUser(user:UserVO) : void
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.UPDATE, user.password, user.username );
			execute( statement );
		}
		
		protected function execute(statement:String) : void
		{
			sql.executeAsync( statement, responder, UserVO );
		}
	}
}
