
package air.cairngorm.async.example.commands
{
	import com.adobe.cairngorm.CairngormError;
	import com.adobe.cairngorm.CairngormMessageCodes;
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.ericfeminella.air.cairngorm.business.ISQLResponder;
	import air.cairngorm.async.example.business.UserServiceDelegate;
	import air.cairngorm.async.example.events.ServiceErrorEvent;
	import air.cairngorm.async.example.model.ModelLocator;
	import flash.data.SQLResult;
	import flash.errors.SQLError;
	
	internal class AbstractSQLServiceCommand implements ICommand, ISQLResponder
	{
		[Bindable]
		protected var model:ModelLocator = ModelLocator.getInstance();
		protected var delegate:UserServiceDelegate;
		
		public function execute(event:CairngormEvent) : void
		{
			delegate = new UserServiceDelegate( this );
		}
		
		public function result(evt:SQLResult) : void 
		{
			throw new CairngormError( CairngormMessageCodes.ABSTRACT_METHOD_CALLED, "result" );
		}
		
		public function fault(error:SQLError) : void 
		{
			new ServiceErrorEvent( error.message ).dispatch();
		}
	}
}

