
package air.cairngorm.async.example.commands
{
	import com.adobe.cairngorm.control.CairngormEvent;
	import air.cairngorm.async.example.business.UserServiceDelegate;
	import air.cairngorm.async.example.vo.UserVO;
	import flash.data.SQLResult;
	import flash.errors.SQLError;
	import mx.collections.ArrayCollection;
	
	public final class SelectUsersCommand extends AbstractSQLServiceCommand
	{
		public override function execute(event:CairngormEvent):void
		{	
			super.execute( event );
			delegate.selectUsers();
		}
		
		public override function result(evt:SQLResult):void
		{
			var users:ArrayCollection = new ArrayCollection();
            var data:Object = evt.data;
            model.users = null;
            
            if ( data != null )
            {
				var n:int = data.length;
				
				for (var i:int = 0; i < n; i++) 
				{
					var user:UserVO = data[i];
					users.addItem( user );
				}
				model.users = users;
            }
		}
		
		public override function fault(error:SQLError):void
		{
			if ( error )
			{
				new CreateTableCommand().execute( null );
			}
		}
	}
}

