package air.cairngorm.sync.example.business
{
	import com.ericfeminella.air.cairngorm.business.AIRServiceLocator;
	import com.ericfeminella.air.cairngorm.business.ISQLResponder;
	import com.ericfeminella.air.cairngorm.business.SQLService;
	import com.ericfeminella.air.cairngorm.business.SQLStatementHelper;
	import air.cairngorm.sync.example.vo.UserVO;
	import flash.data.SQLResult;
	
	public final class UserServiceDelegate
	{
		protected var service:SQLService;
		
		public function UserServiceDelegate()
		{
			this.service = AIRServiceLocator.getInstance().getSQLService( Services.USERS_SERVICE );
		}
		
		public function createUserTable() : SQLResult
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.CREATE_TABLE );
			return execute( statement );
		}
		
		public function addUser(user:UserVO) : SQLResult
		{	
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.INSERT, user.username, user.password );
			return execute( statement );
		}
		
		public function deleteUser(username:String) : SQLResult
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.DELETE, username );
			return execute( statement );
		}
		
		public function selectUsers() : SQLResult
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.SELECT );
			return execute( statement );
		}
				
		public function updateUser(user:UserVO) : SQLResult
		{
			var statement:String = SQLStatementHelper.create( SQLStatementConfiguration.UPDATE, user.password, user.username );
			return execute( statement );
		}
		
		protected function execute(statement:String) : SQLResult
		{
			return service.execute( statement, UserVO );
		}
	}
}
