
package air.cairngorm.sync.example.commands
{
	import com.adobe.cairngorm.control.CairngormEvent;
	import air.cairngorm.sync.example.business.UserServiceDelegate;
	import air.cairngorm.sync.example.vo.UserVO;
	import flash.data.SQLResult;
	import flash.errors.SQLError;
	import mx.collections.ArrayCollection;
	
	public final class SelectUsersCommand extends AbstractSQLServiceCommand
	{
		public override function execute(event:CairngormEvent):void
		{	
			try {
				var result:SQLResult = delegate.selectUsers();
				getUsers( result );
			}
			catch (error:SQLError)
			{
				delegate.createUserTable();
			}
		}
		
		public function getUsers(result:SQLResult) : void
		{
			if ( result != null )
			{
				model.users = null;
				
				if ( result.data != null )
			    {
					var users:ArrayCollection = new ArrayCollection();
		            var data:Object = result.data;
		            
					var n:int = data.length;
					
					for (var i:int = 0; i < n; i++) 
					{
						var user:UserVO = data[i];
						users.addItem( user );
					}
					model.users = users;	
			    }		
			}
		}
	}
}

