/*
 Copyright (c) 2007 www.ericfeminella.com. All Rights Reserved

 AIR Cairngorm: version 1.1.4
 
 @author  Eric J. Feminella
 @contact eric@ericfeminella.com

 @internal
 */

package air.cairngorm.sync.example.model
{
	import com.adobe.cairngorm.CairngormError;
	import com.adobe.cairngorm.CairngormMessageCodes;
	import com.adobe.cairngorm.model.IModelLocator;
	import air.cairngorm.sync.example.vo.UserVO;
	import mx.collections.ArrayCollection;
    
    [Bindable]
	public class ModelLocator implements IModelLocator
	{
		private static var instance:ModelLocator;
		
        public var users:ArrayCollection = new ArrayCollection();
        public var selectedUser:UserVO;
        public var resultMessage:String;
        
		public function ModelLocator()
		{
			if ( instance != null )
			{
				throw new CairngormError( CairngormMessageCodes.SINGLETON_EXCEPTION, "ModelLocator" );
			}
            instance = this;		
		}
		 
		/**
		 * Returns the Singleton instance of GoalManagerModelLocator
		 */
		public static function getInstance() : ModelLocator
		{
			if (instance == null)
			{
				instance = new ModelLocator();
			}
			return instance;
		}
	}
}
